# Isabel Lomas

.data

en: .asciiz "Enter a number: "
ye: .asciiz "You entered: "
tl: .asciiz "\nThe largest of which is: "
space: .asciiz " "
arr: .word 1, 2, 3, 4, 5

.text

# We need to loop 5 times to capture 5 numbers
la $s0, arr		# Load array into $s0
addi $s1, $0, 0 	# Start at index 0
addi $t1, $0, 5 	# 5 iterations

in_loop:
	slt $t0, $s1, $t1 	# $t0 = 0 when we are at 5 iterations
	beq $t0, $0, afl	# If we're at 5 iterations, break
	sll $t2, $s1, 2		# $t2 is the byte offset, 4*index to get the correct words
	add $t2, $t2, $s0	# $t2 is now the address of the array we're writing to
	li $v0, 4 		# Printing a string
	la $a0, en		# Load in "Enter a number"
	syscall
	li $v0, 5 		# Reading integer...
	syscall
	sw $v0, ($t2)	# Store input to $s0 (arr) with the $t2 offset sw $v0, $t2($s0)
	addi $s1, $s1, 1	# Add 1 to index
	j in_loop 		# repeat

afl:	# 'After First Loop'
	li $v0, 4	# Printing "You entered: " line
	la $a0, ye	# Printing "You entered: " line
	syscall
	# Need to return the 5 numbers and largest of the 5.
	addi $s3, $0, 0		# $s3 will store the largest number. Start at 0 (hopefully no negative numbers)
	addi $s1, $0, 0 	# Start at index 0
	addi $t1, $0, 5 	# 5 iterations
	j out_loop

out_loop:
	slt $t0, $s1, $t1 	# $t0 = 0 when we are at 5 iterations
	beq $t0, $0, final	# Move to final if we've printed all 5 numbers
	sll $t3, $s1, 2		# $t3 is the byte offset, 4*index to get the correct words
	add $t3, $t3, $s0	# $t3 is now the address of the array we're reading from
	lw $a0, ($t3)		# Load integer to $a0
	li $v0, 1		# Printing integer...
	syscall

	jal check_max		# Function to check if a new max is needed, then store it.
				# $a0 = number to check
	la $a0, space
	li $v0, 4		# Printing space...
	syscall
	
	# jal to code that will store the highest number (with break if greater than)
	# use jr $ra to come back to
	addi $s1, $s1, 1	# Add 1 to index
	j out_loop
	syscall

check_max:
	blt $a0, $s3, return_workaround	# If a new max does not need to be saved, immediately return to loop
	move $s3, $a0		# Otherwise, if there is a new max, save it.
	jr $ra			# Then return to loop

return_workaround:
	jr $ra

final:
	li $v0, 4	# Printing largest...
	la $a0, tl	# Printing largest...
	syscall
	li $v0, 1	# Printing the actual number
	move $a0, $s3	# Printing the actual number
	syscall
	
	li $v0, 10 	# Exiting program...
	syscall